#include < amxmodx >
#include < amxmisc >
#include < ea_rank >

#define PLUGIN "EvilArmy Menu"
#define VERSION "1.1"
#define AUTHOR "OverGame"

#pragma tabsize 0

new gSLang, s_Lang[64]

public plugin_init()
{
        register_plugin(PLUGIN, VERSION, AUTHOR)
		register_clcmd("menu", "menu_server")
        register_clcmd("say /menu", "menu_server")
		
		gSLang	= register_cvar("amx_auto_rus", "1")
		
		register_dictionary("ea_lang.txt")
}

public client_putinserver(id)
{
        s_Lang[id] = get_pcvar_num(gSLang)
}

public menu_server(id)
{
        new s_Rank[64]
        new rankname = get_ea_rank(id)
		formatex(s_Rank, charsmax(s_Rank), "I_%d", rankname)
		
        static s_MenuItem[255]
        formatex(s_MenuItem, charsmax(s_MenuItem), "\d[%L]\r Меню сервера^n\yЗвание : \r%L", LANG_PLAYER, "SVR_PREFIX", LANG_PLAYER, s_Rank)
		
        new menu = menu_create(s_MenuItem, "menu_handler" )
		
        menu_additem(menu, "\yОбнулить Счет","1")
		menu_additem(menu, "\yЗабанить игрока","2")
		
		if ( s_Lang[id] == 1 )
		{
        menu_additem(menu, "\yЯзык : \rРусский","3")
		} else {
		menu_additem(menu, "\yЯзык : \rАнглийский","3")
		}
		
		menu_additem(menu, "\yУзнать свой ранг","4")
		menu_additem(menu, "\yУзнать свою стату","5")
		
		menu_setprop(menu, MPROP_BACKNAME, "Назад")
		menu_setprop(menu, MPROP_NEXTNAME, "Далее")
        menu_setprop(menu, MPROP_EXITNAME, "Выход")
 
        menu_display(id,menu,0)
        return PLUGIN_HANDLED
}

public menu_handler(id, menu, item)
{
        if(item == MENU_EXIT)
        {
                menu_destroy(menu)
                return PLUGIN_HANDLED
        }
 
        new data[6], iName[64], access, callback
        menu_item_getinfo(menu, item, access, data, 5, iName, 63, callback)
 
        new key = str_to_num(data)
 
        switch(key)
        {
        case 1:{
                        client_cmd(id, "say /rs")
                        menu_server(id)
                }
        case 2:{
                        client_cmd(id, "say /voteban")
                }
        case 3:{
                        if ( s_Lang[id] == 1 )
						{
						client_cmd(id, "say /eng")
						s_Lang[id] = 0
						} else {
						client_cmd(id, "say /rus")
						s_Lang[id] = 1
						}
						menu_server(id)
                }
        case 4:{
                        client_cmd(id, "say /erank")
						menu_server(id)
                }
        case 5:{
                        client_cmd(id, "say /estats")
						menu_server(id)
                }
        }
        return PLUGIN_HANDLED
}