//==============[vk.com/plugins_by_overgame]==================
//+ Поддержка EvilArmy
//+ Исправлены некоторые баги
//+ Чистый код
//Автор доработки : OverGame
//Автор оригинала : FatalisDK
//==============[vk.com/plugins_by_overgame]==================

#include < amxmodx >
#include < fakemeta >
#include < ea_rank >

#pragma tabsize 0

#define RED 64
#define GREEN 64
#define BLUE 64
#define UPDATEINTERVAL 1.0

#define ECHOCMD

#define FLAG ADMIN_IMMUNITY

new const PLUGIN[] = "EvilSpecList";
new const VERSION[] = "1.2a";
new const AUTHOR[] = "FatalisDK";

new cl_r, cl_g, cl_b

new gMaxPlayers;
new gCvarOn;
new gCvarImmunity;
new bool:gOnOff[33] = { true, ... };

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	register_cvar(PLUGIN, VERSION, FCVAR_SERVER, 0.0);
	gCvarOn = register_cvar("ea_speclist", "1", 0, 0.0);
	gCvarImmunity = register_cvar("amx_speclist_immunity", "0", 0, 0.0);
	
	register_clcmd("say /speclist", "cmdSpecList", -1, "");
	
	cl_r            = register_cvar( "cl_r",   	"100");
	cl_g            = register_cvar( "cl_g",   	"100");
	cl_b            = register_cvar( "cl_b",   	"100");
	
	gMaxPlayers = get_maxplayers();
	
	set_task(UPDATEINTERVAL, "tskShowSpec", 123094, "", 0, "b", 0);
	
	register_dictionary("ea_lang.txt");
}

public cmdSpecList(id)
{
	if( gOnOff[id] )
	{
		client_print(id, print_chat, "[AMXX] You will no longer see who's spectating you.");
		gOnOff[id] = false;
	}
	else
	{
		client_print(id, print_chat, "[AMXX] You will now see who's spectating you.");
		gOnOff[id] = true;
	}
	
	#if defined ECHOCMD
	return PLUGIN_CONTINUE;
	#else
	return PLUGIN_HANDLED;
	#endif
}

public tskShowSpec()
{
	if( !get_pcvar_num(gCvarOn) )
	{
		return PLUGIN_HANDLED;
	}
	
	static szHud[1102];
	static szName[34];
	static bool:send;
	
	for( new alive = 1; alive <= gMaxPlayers; alive++ )
	{
		new bool:sendTo[33];
		send = false;
		
		if( !is_user_alive(alive) )
		{
			continue;
		}
		
		sendTo[alive] = true;
		
		get_user_name(alive, szName, 32);
		
		new s_Rank[64]
		new rankname = get_ea_rank(alive);
		formatex(s_Rank, charsmax(s_Rank), "I_%d", rankname)
		
		format(szHud, 255, "Наблюдение : %s^nЗвание : %L^n^n", szName, LANG_PLAYER, s_Rank);
		
		for( new dead = 1; dead <= gMaxPlayers; dead++ )
		{
			if( is_user_connected(dead) )
			{
				if( is_user_alive(dead)
				|| is_user_bot(dead) )
				{
					continue;
				}
				
				if( pev(dead, pev_iuser2) == alive )
				{
					if( !(get_pcvar_num(gCvarImmunity)&&get_user_flags(dead, 0)&FLAG) )
					{
						get_user_name(dead, szName, 32);
						add(szName, 33, "^n", 0);
						add(szHud, 1101, szName, 0);
						send = true;
					}

					sendTo[dead] = true;
					
				}
			}
		}
		
		if( send == true )
		{
			for( new i = 1; i <= gMaxPlayers; i++ )
			{
				if( sendTo[i] == true
				&& gOnOff[i] == true )
				{
					set_hudmessage(get_pcvar_num(cl_r),get_pcvar_num(cl_g),get_pcvar_num(cl_b), 0.75, 0.20, 0, 15.0, UPDATEINTERVAL + 0.1, _, _, -1)
					
					show_hudmessage(i, szHud);
				}
			}
		}
	}
	
	return PLUGIN_CONTINUE;
}

public client_connect(id)
{
	gOnOff[id] = false;
}

public client_disconnect(id)
{
	gOnOff[id] = true;
}
